// - Nastaveni projektu: output path, output type, target framework (kde a co je vystup)
// - Struktura aplikace: reference, Namespace, using, classes
// - try, catch
// - Debugging, F10,F11, vraceni provedene operace
//      - krokujte program, Okna: Watch, BreakPoints, conditional break point, call stack object browser
//      - vyskousejte System.Diagnostics.Debug.Write("");
// - vytvorte namespace IW5_cv01.Math v novem projektu typu knihovna, pridejte referenci
//      - v tomto projektu vytvorte funkce pro nasobeni, deleni, odcitani a stitani
// - vyuzitim tohoto suboru vytvorte jednoduchy kalkulator v konzoli
// - vyskousejte praci s parametry args, s kterymi byla aplikace spustena,
//      - (Project > Properties > Debug > Command line arguments)
// - Zkuste puzivat System.Math funkce
// - pozor na deleni nulou!

using System;

namespace IW5_cv01
{
    internal class Program
    {
        /// <summary>
        /// function Main - has to be static, has to have name "Main", doesn't have return value
        ///                 cannot call non-static methods
        /// </summary>
        /// <param name="args">array of strings which represents parameters of program</param>
        private static void Main(string[] args)
        {
            RunForLoop();

            RunWhileLoop();

            ShowIf(5);

            GetInput();

            // stop the program at the end
            WaitForPressedKey();
        }

        #region Students final task

        //#region Command arguments evaluation
        ///// <summary>
        ///// CommandLine parser settings
        ///// https://commandline.codeplex.com/
        ///// </summary>
        //class Options
        //{

        //    [Option('f', "first", Required = true,
        //      HelpText = "The first operand.")]
        //    public int? First { get; set; }

        //    [Option('s', "second", Required = true,
        //      HelpText = "The second operand.")]
        //    public int? Second { get; set; }


        //    [Option('v', "verbose", DefaultValue = false,
        //      HelpText = "Prints all messages to standard output.")]
        //    public bool Verbose { get; set; }

        //    [HelpOption]
        //    public string GetUsage()
        //    {
        //        var help = new HelpText
        //        {
        //            Heading = new HeadingInfo("<<app title>>", "<<app version>>"),
        //            Copyright = new CopyrightInfo("<<app author>>", DateTime.Now.Year),
        //            AdditionalNewLineAfterOption = true,
        //            AddDashesToOption = true
        //        };
        //        help.AddPreOptionsLine("<<license details here.>>");
        //        help.AddPreOptionsLine("Usage: app -f 4 -s 3");
        //        help.AddOptions(this);
        //        return help;
        //    }

        //}

        ///// <summary>
        ///// Parses commandline agruments
        ///// </summary>
        ///// <param name="args">Command line arguments</param>
        ///// <returns>Parsed arguments</returns>
        //private static Options ParseCommandLineCommands(string[] args)
        //{
        //    var options = new Options();
        //    if (!CommandLine.Parser.Default.ParseArguments(args, options))
        //    {
        //        throw new IncorrentCommandLineArguments("Bad arguments!", options);
        //    }
        //    return options;
        //}

        ///// <summary>
        ///// Executes intended program behaviour
        ///// </summary>
        ///// <param name="options">Parsed command line arguments</param>
        //private static void ExecuteCommandLineCommands(Options options)
        //{

        //}

        //class IncorrentCommandLineArguments : ArgumentException
        //{
        //    private string _message;

        //    /// <summary>
        //    /// Auto-implemented property, uses autogenerated backing field
        //    /// </summary>
        //    public Options CmdLineOptions { get; private set; }

        //    /// <summary>
        //    /// Property with backing field, may add some inner functionality like input checking
        //    /// </summary>
        //    public new string Message
        //    {
        //        get { return _message; }
        //        set
        //        {
        //            if (value == null)
        //            {
        //                _message = string.Empty;
        //            }
        //            _message = value;
        //        }
        //    }

        //    public IncorrentCommandLineArguments(string message, Options cmdLineOptions)
        //        : base(message)
        //    {
        //        CmdLineOptions = cmdLineOptions;
        //    }
        //}
        //#endregion

        #endregion

        /// <summary>
        /// Runs for loop, note: has to be static if we want to call it from Main
        /// </summary>
        private static void RunForLoop()
        {
            for (int i = 0; i < 10; i++)
            {
                Console.WriteLine("For: {0}", i.ToString());
            }
        }

        /// <summary>
        /// Runs while loop, note: has to be static if we want to call it from Main
        /// </summary>
        private static void RunWhileLoop()
        {
            int index = 0;

            while (index < 11)
            {
                index = index + 1;
                Console.WriteLine("Do - while: {0}", index.ToString());
            }
        }

        /// <summary>
        /// Shows if branching, note: has to be static if we want to call it from Main
        /// </summary>
        private static void ShowIf(int condition)
        {
            if (condition > 3)
            {
                Console.WriteLine("condition is greater than 3");
            }
            else
            {
                Console.WriteLine("condition is not greater than 3");
            }
        }

        /// <summary>
        /// Gets input from keyboard, note: has to be static if we want to call it from Main
        /// </summary>
        private static void GetInput()
        {
            try
            {
                Console.WriteLine("Waiting for input (number)...");
                int a = Convert.ToInt32(Console.ReadLine());
                Console.WriteLine("Input: {0}", a);
            }
            catch (FormatException exception)
            {
                Console.WriteLine(exception.Message);
            }
            catch (Exception exception)
            {
                Console.WriteLine(exception.Message);
                throw new ApplicationException("HUpsss....");
            }
            finally
            {
                // executed always after the try and/or catch
                Console.WriteLine("Release resources... cleaning after my self");
            }
        }

        /// <summary>
        /// Helper - waits for pressed any key on keyboard.
        /// Holds the command prompt opened before program exits.
        /// </summary>
        private static void WaitForPressedKey()
        {
            Console.WriteLine("Press the key...");
            Console.ReadKey();
        }

        /// <summary>
        /// Calculates basic mathematical operations (+,-,*,/) on given operands using 
        /// mathematical assembly implemented by students them selves.
        /// Writes results on console.
        /// </summary>
        private static void Calculator()
        {
        }
    }
}